unit UDemo;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants, 
  FMX.Types, FMX.Graphics, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.StdCtrls,
  FMX.TMSBaseControl, FMX.TMSTreeViewBase, FMX.TMSTreeViewData,
  FMX.TMSCustomTreeView, FMX.TMSTreeView, FMX.Edit, FMX.TMSDirectoryTreeView,
  FMX.Layouts, FMX.Controls.Presentation;

type
  TForm96 = class(TForm)
    TMSFMXDirectoryTreeView1: TTMSFMXDirectoryTreeView;
    Edit1: TEdit;
    Button1: TButton;
    Layout1: TLayout;
    Layout2: TLayout;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Layout3: TLayout;
    Button2: TButton;
    Edit2: TEdit;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TMSFMXDirectoryTreeView1AfterSelectNode(Sender: TObject;
      ANode: TTMSFMXTreeViewVirtualNode);
    procedure CheckBox2Change(Sender: TObject);
    procedure TMSFMXDirectoryTreeView1AfterCollapseNode(Sender: TObject;
      ANode: TTMSFMXTreeViewVirtualNode);
    procedure TMSFMXDirectoryTreeView1AfterExpandNode(Sender: TObject;
      ANode: TTMSFMXTreeViewVirtualNode);
    procedure CheckBox3Change(Sender: TObject);
    procedure CheckBox4Change(Sender: TObject);
    procedure TMSFMXDirectoryTreeView1GetCustomNodeText(Sender: TObject;
      ANode: TTMSFMXTreeViewNode; AColumn: Integer; AFile: string;
      var AText: string);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox6Change(Sender: TObject);
    procedure CheckBox5Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure AutoSizeColumns;
  end;

var
  Form96: TForm96;

implementation

{$R *.fmx}

uses
  IOUtils;

procedure TForm96.AutoSizeColumns;
var
  I: Integer;
begin
  if CheckBox1.isChecked then
  begin
    for I := 0 to TMSFMXDirectoryTreeView1.Columns.Count - 1 do
      TMSFMXDirectoryTreeView1.AutoSizeColumn(I);
  end;
end;

procedure TForm96.Button1Click(Sender: TObject);
var
  dir: string;
begin
  if SelectDirectory('Select Directory', TPath.GetDocumentsPath, dir) then
  begin
    Edit1.Text := dir;
    TMSFMXDirectoryTreeView1.LoadDirectory(dir);
    AutoSizeColumns;
  end;
end;

procedure TForm96.Button2Click(Sender: TObject);
begin
  TMSFMXDirectoryTreeView1.Filter := Edit2.Text;
end;

procedure TForm96.CheckBox2Change(Sender: TObject);
begin
  TMSFMXDirectoryTreeView1.ColumnsAppearance.Stretch := CheckBox2.IsChecked;
end;

procedure TForm96.CheckBox3Change(Sender: TObject);
begin
  TMSFMXDirectoryTreeView1.NodesAppearance.ShowLines := CheckBox3.IsChecked;
end;

procedure TForm96.CheckBox4Change(Sender: TObject);
begin
  TMSFMXDirectoryTreeView1.Interaction.ColumnSizing := CheckBox4.IsChecked;
end;

procedure TForm96.CheckBox5Change(Sender: TObject);
begin
  TMSFMXDirectoryTreeView1.Columns[3].Visible := CheckBox5.IsChecked;
end;

procedure TForm96.CheckBox6Change(Sender: TObject);
begin
  TMSFMXDirectoryTreeView1.Columns[2].Visible := CheckBox6.IsChecked;
end;

procedure TForm96.FormCreate(Sender: TObject);
begin
  TMSFMXDirectoryTreeView1.Interaction.ColumnAutoSizeOnDblClick := True;
  TMSFMXDirectoryTreeView1.Interaction.ColumnSizing := True;
  TMSFMXDirectoryTreeView1.AddColumn(tvckName);
  TMSFMXDirectoryTreeView1.AddColumn(tvckDisplayName);
  TMSFMXDirectoryTreeView1.AddColumn(tvckCreationDate).Visible := False;
  TMSFMXDirectoryTreeView1.AddColumn(tvckModificationDate).Visible := False;
  TMSFMXDirectoryTreeView1.AddColumn(tvckCustom).Text := 'Extension';
  TMSFMXDirectoryTreeView1.AddColumn(tvckTotalSize);
  TMSFMXDirectoryTreeView1.AddColumn(tvckFreeSpaceAndTotalSize);
  TMSFMXDirectoryTreeView1.LoadDrives;
  AutoSizeColumns;
end;

procedure TForm96.TMSFMXDirectoryTreeView1AfterCollapseNode(Sender: TObject;
  ANode: TTMSFMXTreeViewVirtualNode);
begin
  AutoSizeColumns;
end;

procedure TForm96.TMSFMXDirectoryTreeView1AfterExpandNode(Sender: TObject;
  ANode: TTMSFMXTreeViewVirtualNode);
begin
  AutoSizeColumns;
end;

procedure TForm96.TMSFMXDirectoryTreeView1AfterSelectNode(Sender: TObject;
  ANode: TTMSFMXTreeViewVirtualNode);
begin
  if Assigned(ANode.Node) then
    Edit1.Text := TTMSFMXDirectoryTreeViewNode(ANode.Node).FileName;
end;

procedure TForm96.TMSFMXDirectoryTreeView1GetCustomNodeText(Sender: TObject;
  ANode: TTMSFMXTreeViewNode; AColumn: Integer; AFile: string;
  var AText: string);
begin
  if AColumn = 2 then
    AText := ExtractFileExt(AFile);
end;

end.
